/* dcl.c
	parse declaration
	P.Chongstitvatana
					25 Aug 97
  last update				28 Aug 98
*/

#include "compile.h"

#define		PRIVATE		static

int DS = 1;	/* index to data segment */
int mainRef;    /* index to symtab refer to main */
int PID = 2;    /* current PID */

extern FILE *FI,*FO;

pass1()
{
  lex();
  while( tok != tkEOF ) {
    switch( tok ) {
    case tkIDENTIFIER :	idenDcl(); break;
    case tkSEMAPHORE : 	semaphoreDcl(); break;
    case tkPROCESS : 	processDcl(); break;
    case tkMAIN : 	mainDcl(); break;
    default :		seterror("unknow token");
    }
    lex();
  }
}

PRIVATE idenDcl()
{
  int size,type,h;
  char name[NAMELEN];
  strcpy(name,tokstring);
  lex();
  if( tok == tkLPAREN ) functionDcl(name);
  else
  while(tok == tkSEMICOLON || tok == tkCOMMA || tok == tkLBRACKET) {
    size = 1;
    type = tySCALAR;
    if( tok == tkLBRACKET ) {
      size = doindex();
      type = tyVECTOR;
      lex();
    }
    if( lookup(name,&h) ) seterror("redefine global name");
    enterGlobal(name,type,DS,size,0,h);
    DS += size;
    if( tok == tkSEMICOLON ) break;
    expect(tkCOMMA,"expect ,");
    lex();
    expect(tkIDENTIFIER,"expect identifier");
    strcpy(name,tokstring);
    lex();
  }
}

PRIVATE functionDcl(char *name)
{
  int h,a,pv;
  if( lookup(name,&h) ) seterror("redefine function");
  a = enterGlobal(name,tyFUNCTION,0,0,0,h);
  fprintf(FO,"%d ",a);
  pv = formalParam();
  putSymtabArg(a, pv);
  copyBody();
}

PRIVATE int doindex()
{
  int a;
  lex();
  expect(tkNUMBER,"size of array must be number");
  a = atoi(tokstring);
  lex();
  expect(tkRBRACKET,"expect ]");
  return a;
}

PRIVATE semaphoreDcl()
{
  int h;
  lex();
  expect(tkIDENTIFIER,"semaphore declaration, expect identifier");
  while( tok == tkIDENTIFIER ) {
    if( lookup(tokstring,&h) ) seterror("redefine semaphore");
    enterGlobal(tokstring,tySEMAPHORE,DS,0,0,h);
    DS += 2;
    lex();
    if( tok != tkSEMICOLON ) {
      expect(tkCOMMA,"expect ,");
      lex();
    }
  }
  expect(tkSEMICOLON,"expect ;");
}

PRIVATE mainDcl()
{
  int h,a;
  if( lookup(tokstring,&h) ) seterror("redefine main");
  a = enterGlobal(tokstring,tyPROCESS,0,0,1,h);
  mainRef = a;
  fprintf(FO,"%d ",a);
  lex();
  expect(tkLPAREN,"main, expect (");
  lex();
  expect(tkRPAREN,"expect )");
  copyBody();
}

PRIVATE processDcl()
{
  int h,a,pv;
  lex();
  expect(tkIDENTIFIER,"process declaration, expect identifier");
  if( lookup(tokstring,&h) ) seterror("redefine process");
  lex();
  expect(tkLPAREN,"expect (");
  a = enterGlobal(tokstring,tyPROCESS,0,0,PID,h);
  PID++;
  fprintf(FO,"%d ",a);
  pv = formalParam();
  putSymtabArg(a, pv);
  copyBody();
}

PRIVATE int formalParam()
{
  int pv = 0;
  lex();
  while( tok == tkIDENTIFIER ) {
    fprintf(FO,"%s ",tokstring);
    pv++;
    lex();
    if( tok == tkRPAREN ) break;
    expect(tkCOMMA,"expect ,");
    lex();
  }
  expect(tkRPAREN,"expect )");
  return pv;
}

PRIVATE copyBody()
{
  int c, cnt = 1;
  lex();
  expect(tkLBRACE,"expect {");
  fprintf(FO,"\n%d {",line);
  if( CH == EOF_CHAR ) seterror("unexpect EOF");
  c = CH;
  while( cnt > 0 && c != EOF ) {
    switch( c ) {
    case '{'     : cnt++; putc(c,FO);break;
    case '}'     : cnt--; putc(c,FO); break;
    case NL_CHAR : line++; putc(c,FO); break;
    case '/'     : c = getc(FI);
		   if( c == '/' ) {
		     while( c != NL_CHAR && c != EOF )
		       c = getc(FI);
		     if( c == NL_CHAR ) {
		       line++;
		       putc(c,FO);
		     }
		   } else {
		     ungetc(c,FI);
		     putc('/',FO);
		   }
		   break;
    default      : putc(c,FO);
    }
    c = getc(FI);
  }
  putc('\n',FO);
  CH = ( c == EOF ) ? EOF_CHAR : c;
}
